#include "stdafx.h"

CProtocolSegment :: CProtocolSegment( const char * pchDur, double dV0a, double dV1a, bool bV0, bool bV1, 
		double dV0b, double dV1b, const char * pchFunction, bool bModifiable, int iRepeat ) { 
	Set( pchDur, dV0a, dV1a, bV0, bV1, dV0b, dV1b, pchFunction, bModifiable, iRepeat );
	} 

int CProtocolSegment :: GetDuration( double d ) { 
	return m_oDuration.m_bValid ? int(m_oDuration.Evaluate( &d )) : 100;
	}
	
bool CProtocolSegment :: SetDuration( const char * pchDuration ){ 
	m_cDuration.Set( pchDuration );
	m_oDuration.Parse( pchDuration, "i\0\0" );
	return true;
	}


//-----
double CProtocolSegment :: GetV0() { 
	return m_dV0a; 
	}
double CProtocolSegment :: GetV0Final() { 
	return m_dV0b; 
	}
void CProtocolSegment :: SetV0( double dVa ) { 
	m_dV0a=dVa; 
	}
void CProtocolSegment :: SetV0Final( double dVb ) { 
	m_dV0b=dVb; 
	}
void CProtocolSegment :: SetV0(double dVa, bool bRange, double dVb ) { 
	m_dV0a=dVa; 
	m_dV0b=dVb; 
	m_bV0Range=bRange;
	}

//-----
double CProtocolSegment :: GetV1() { 
	return m_dV1a; 
	}
double CProtocolSegment :: GetV1Final() { 
	return m_dV1b; 
	}

void CProtocolSegment :: SetV1( double dVa ) { 
	m_dV1a=dVa; 
	}
void CProtocolSegment :: SetV1Final( double dVb ) { 
	m_dV1b=dVb; 
	}

void CProtocolSegment :: SetV1(double dVa, bool bRange, double dVb ) { 
	m_dV1a=dVa; 
	m_dV1b=dVb; 
	m_bV1Range=bRange;
	}

void CProtocolSegment :: Set( const char * pchDur, double dV0a, double dV1a, bool bV0Range, bool bV1Range, 
			double dV0b, double dV1b, const char * pchFunction, bool bModifiable, int iRepeat ) { 
	SetDuration( pchDur );
	m_dV0a=dV0a;
	m_dV1a=dV1a;
	m_dV0b=dV0b;
	m_dV1b=dV1b;
	m_bV0Range=bV0Range;
	m_bV1Range=bV1Range;
	m_cFunction.Set( pchFunction==NULL?"":pchFunction );
	m_bModifiable=bModifiable;
	m_iRepeatCount=iRepeat;
	} 

bool CProtocolSegment :: LoadFromFile( FILE * h, int iVer ){
	m_bModifiable=false;	// for pre v.2 
	if( iVer>=4 ) { 
		if( ! FileLoadString( h, &m_cDuration ) 
				|| ! SetDuration( m_cDuration.Buffer() ) ) 
			return false;
		}
	else { 
		int iDur;
		if( fread( &iDur, sizeof(iDur), 1, h ) != 1 )			
			return false;
		char buf[16];
		sprintf( buf, "%d", iDur );
		m_cDuration.Set( buf );
		}
	
	return fread( &m_dV0a, sizeof(m_dV0a), 1, h ) == 1 
		&& fread( &m_dV1a, sizeof(m_dV1a), 1, h ) == 1 
		&& ( iVer<=3 || ( fread( &m_dV0b, sizeof(m_dV0b), 1, h ) == 1 
						&& fread( &m_dV1b, sizeof(m_dV1b), 1, h ) == 1 
						&& fread( &m_bV0Range, sizeof(m_bV0Range), 1, h ) == 1 
						&& fread( &m_bV1Range, sizeof(m_bV1Range), 1, h ) == 1 
						&& fread( &m_bModifiable, sizeof(m_bModifiable), 1,h ) == 1 
						&& fread( &m_iRepeatCount, sizeof(m_iRepeatCount), 1,h ) == 1 
						) 
			)
		&& FileLoadString( h, &m_cFunction );
	}
	
bool CProtocolSegment :: SaveToFile( FILE * h ){
	return FileSaveString( h, m_cDuration.Buffer() ) 
		&& fwrite( &m_dV0a, sizeof(m_dV0a), 1, h ) == 1 
		&& fwrite( &m_dV1a, sizeof(m_dV1a), 1, h ) == 1 
		&& fwrite( &m_dV0b, sizeof(m_dV0b), 1, h ) == 1 
		&& fwrite( &m_dV1b, sizeof(m_dV1b), 1, h ) == 1 
		&& fwrite( &m_bV0Range, sizeof(m_bV0Range), 1, h ) == 1 
		&& fwrite( &m_bV1Range, sizeof(m_bV1Range), 1, h ) == 1 
		&& fwrite( &m_bModifiable, sizeof(m_bModifiable), 1,h ) == 1 
		&& fwrite( &m_iRepeatCount, sizeof(m_iRepeatCount), 1,h ) == 1 
		&& FileSaveString( h, m_cFunction.Buffer() );
	}

void CProtocolSegment :: Parse() { 
	if( m_cFunction.Length()==0 ) 
		m_oExpr.Parse( "u*(1-t)+v*t", "i\0t\0u\0v\0\0" );
	else if( ! m_oExpr.Parse( m_cFunction.Buffer(), "i\0t\0u\0v\0\0" ) ) 
		m_oExpr.Parse( "u", "i\0t\0u\0v\0\0" );
	}

//-- fill in u and v parameters	for aVal[2], aVal[3] baed on iteration
void CProtocolSegment :: CalcAval1( double * aVal, int iPos, int iLen ) { 
	if( m_iRepeatCount>1 && m_iRepeatCount<100 ) 
		aVal[1] = double(iPos % max(1, iLen / m_iRepeatCount )) / double(max(1,iLen-1)) * m_iRepeatCount;
	else 
		aVal[1] = double(iPos) / double(max(1,iLen-1));
	}
	
void CProtocolSegment :: CalcAVal23( double * aVal, int iIter, int iIters ) { 
	double dIter = double(iIter) / max(1,iIters-1);
	if( m_bV0Range )
		aVal[2] = GetV0()*(1.0-dIter) + GetV0Final()*dIter;
	else
		aVal[2] = GetV0();

	if( m_bV1Range )
		aVal[3] = GetV1()*(1.0-dIter) + GetV1Final()*dIter;
	else
		aVal[3] = GetV1();
	}

	
//-----------------------------------------------------------------------------
CProtocol :: CProtocol() { 
	m_iIterations=1;
	m_bRandom=false;
	m_aiIterationMap=NULL;
	m_dYMin=-10.0;
	m_dYMax=10.0;
	m_bHasModifiable=false;
	}
	
CProtocol :: ~CProtocol( ) { 
	if( m_aiIterationMap != NULL )
		delete [] m_aiIterationMap ;
	m_aiIterationMap = NULL;
	}
	
bool CProtocol :: AddSegment( const char * pchDuration, double dV0a, double dV1a, bool bV0, bool bV1, 
		double dV0b, double dV1b, const char * pchFunction, bool bModifiable, int iRepeat, int iPos ) { 
	return m_aSeg.AddItem( new CProtocolSegment( pchDuration, dV0a, dV1a, bV0, bV1, dV0b, dV1b, pchFunction, bModifiable, iRepeat), iPos );
	}
		
bool CProtocol :: MoveSegment( int iPos, int iDest ) { 
	return m_aSeg.MoveItem( iPos, iDest );
	} 
	
bool CProtocol :: DelSegment( int iPos ) { 
	return m_aSeg.DeleteItem(iPos);
	} 

double CProtocol :: Range() { 
	return m_dYMax-m_dYMin;
	}

double CProtocol :: Iteration( int iIter ) { 
	return double(iIter)/(double(max(2,m_iIterations))-1.0);
	}

double CProtocol :: IterationMap(int iIter) { 
	int ii=iIter;
	if( m_bRandom )
		ii=m_aiIterationMap[iIter];
	return double(ii)/(double(max(2,m_iIterations))-1.0);
	}

int CProtocol :: Duration( double dIter ) { 
	int iDur=0;
	for( int i=0; i<m_aSeg.Count(); ++i ) 
		iDur += ((CProtocolSegment *)m_aSeg[i])->GetDuration(dIter);
	return iDur;
	}

int CProtocol :: Duration( int iIter ) { 
	return Duration( Iteration( iIter ) );
	}

int CProtocol :: TotalSamples( int iGenRate ) { 
	int iSamp=0;
	// total samples for all iterations
	for( int i=0; i<m_iIterations; ++i ) 
		iSamp += Duration(i);
	return MulDiv( iSamp, iGenRate, 1000 );
	}

int CProtocol :: SegmentFromPos( int iX ){ 
	int iPos=0;
	if( iX < 0 ) 
		return -1;
	for( int iSeg=0; iSeg<m_aSeg.Count(); ++iSeg ) {
		if( iX<iPos+((CProtocolSegment *)m_aSeg[iSeg])->m_iDispWidth ) 
			return iSeg;
		iPos+=((CProtocolSegment *)m_aSeg[iSeg])->m_iDispWidth;
		}
	return -1;
	}
	
bool CProtocol :: LoadFile( const char * pchFile ) { 
	int iVer;
	//-- Open File
	FILE * h = fopen( pchFile, "rb" );
	if( h == NULL ) 
		return false;
	//-- Read Header
	int iCount;
	if( fread( &iVer, sizeof(iVer), 1, h )!=1 
		|| fread( &m_iIterations, sizeof(m_iIterations), 1, h )!=1 
		|| fread( &m_dYMin, sizeof(m_dYMin), 1, h )!=1
		|| fread( &m_dYMax, sizeof(m_dYMin), 1, h )!=1
		|| fread( &iCount, sizeof(iCount), 1, h )!=1  ) {
		fclose(h);
		return false;
		}
	if( iVer >= 3 ) {
		if( fread( &m_bRandom, sizeof(m_bRandom), 1, h ) != 1 )  { 
			fclose(h);
			return false;
			}
		}
	else 
		m_bRandom=false;

	//-- Read Segment data 
	CProtocolSegment oTemp;
	m_aSeg.DeleteAll();
	for( int iSeg=0; iSeg<iCount; ++iSeg ) {
		if ( ! oTemp.LoadFromFile( h, iVer  ) ) {
			fclose(h);
			return false;
			}
		AddSegment( oTemp.m_cDuration.Buffer(), oTemp.GetV0(), oTemp.GetV1(), 
				oTemp.m_bV0Range, oTemp.m_bV1Range, oTemp.GetV0Final(), oTemp.GetV1Final(),
				oTemp.m_cFunction.Buffer(), oTemp.m_bModifiable, oTemp.m_iRepeatCount );
		m_bHasModifiable |= oTemp.m_bModifiable ;
		}
			
	fclose(h);
	return true;
	}
	
bool CProtocol :: SaveFile( const char * pchFile ) { 
	//-- Open File
	FILE * h = fopen( pchFile, "wb" );
	if( h == NULL ) 
		return false;
	//-- Write Header
	//int iVer=1;				
	//int iVer=2;				// ver. 2 add modifiable flag 
	//int iVer=3;				// ver. 3 add Random flag
	int iVer=4;					// ver. 4 add segment: repeat count, u,v range option and duration as f(i)
	
	int iCount=m_aSeg.Count();
	if ( fwrite( &iVer, sizeof(iVer), 1, h )!=1
		|| fwrite( &m_iIterations, sizeof(m_iIterations), 1, h )!=1 
		|| fwrite( &m_dYMin, sizeof(m_dYMin), 1, h )!=1
		|| fwrite( &m_dYMax, sizeof(m_dYMax), 1, h )!=1 
		|| fwrite( &iCount, sizeof(iCount), 1, h )!=1 
		|| fwrite( &m_bRandom, sizeof(m_bRandom), 1, h )!=1 ) {
		fclose(h);
		return false;
		}
	//-- Write Segment data 
	for( int iSeg=0; iSeg<iCount; ++iSeg )
		if ( ! ((CProtocolSegment *)m_aSeg[iSeg])->SaveToFile( h ) ) {
			fclose(h);
			return false;
			}
			
	fclose(h);
	return true;
	}

CProtocolSegment * CProtocol :: Segment( int iSeg ) { 
	if( iSeg<0 || iSeg>=m_aSeg.Count() )
		return NULL;
	return (CProtocolSegment *)m_aSeg[iSeg];
	} 
	
//------------------------------------------------------------------	
bool CProtocol :: GenPrepare( int iGenRate ) { 
	CreateRandomMap( );
	m_iGenSweep=0;
	m_iGenIteration=0;
	m_iGenSegment=0;
	m_iGenSample=0;
	m_iGenRate=iGenRate;
	CProtocolSegment * poSeg;
	for( int iSeg=0; iSeg<m_aSeg.Count(); ++iSeg )  {
		poSeg=Segment(iSeg);
		poSeg->Parse();
		}
	GenSegPrepare();
	return true;
	}

//----- for each segment, set start and length of segment	
bool CProtocol :: GenSegPrepare( ) { 
	double dIter = Iteration( m_iGenIteration );
	int iGenDuration = Duration( m_iGenIteration );
	int iSamplesPerIteration = MulDiv( iGenDuration, m_iGenRate, 1000 );

	int iSumSamp=0, iSumDur=0;
	CProtocolSegment * poSeg;
	for( int iSeg=0; iSeg<m_aSeg.Count(); ++iSeg )  {
		poSeg=Segment(iSeg);
		iSumDur += poSeg->GetDuration( dIter );
		poSeg->m_iGenStart=iSumSamp;
		poSeg->m_iGenLength=MulDiv( iSumDur, iSamplesPerIteration, iGenDuration) - iSumSamp;
		iSumSamp += poSeg->m_iGenLength;
		}
	return true;
	}
	
bool CProtocol :: GenerateData( double * pData, int iCount, bool bRepeat, double dScaling, double dMin, double dMax ) { 
	double aVar[4];
	CProtocolSegment * poSeg = Segment( m_iGenSegment );
	aVar[0]=IterationMap(m_iGenIteration);

	poSeg->CalcAVal23( aVar, m_iGenIteration, m_iIterations);

	for( int i=0; i<iCount; ++i ) { 
		if( ! bRepeat && m_iGenSweep>0 ) 
			pData[i]=0.0;
		else {
			poSeg->CalcAval1( aVar, m_iGenSample-poSeg->m_iGenStart, poSeg->m_iGenLength );
			pData[i] = max( dMin, min( dMax, dScaling * poSeg->m_oExpr.Evaluate( aVar ) ) );
			}
			
		//-- check if past end of segment 
		if( ++m_iGenSample >= poSeg->m_iGenStart+poSeg->m_iGenLength ) { 
			//-- check if past iteration
			if( ++m_iGenSegment>=m_aSeg.Count() ) { 
				m_iGenSegment=0;
				if( ++m_iGenIteration >= m_iIterations ) {
					m_iGenIteration=0;
					++m_iGenSweep;
					}
				GenSegPrepare( );
				aVar[0]=IterationMap(m_iGenIteration);
				m_iGenSample=0;
				}
			//-- set up new segment 
			poSeg = Segment( m_iGenSegment );
			poSeg->CalcAVal23( aVar, m_iGenIteration, m_iIterations);
			}
		}
	return true;
	}
	
void CProtocol :: CreateRandomMap( ) { 
	if( m_aiIterationMap != NULL )
		delete [] m_aiIterationMap ;
	m_aiIterationMap = NULL;

	if( m_bRandom ) { 
		m_aiIterationMap = new int[m_iIterations];
		for( int i=0; i<m_iIterations; ++i ) 
			m_aiIterationMap[i]=i;
		int iSel, iTemp;
		for( int i=0; i<m_iIterations-1; ++i ) {
			do {
				iSel = MulDiv( rand(), m_iIterations-i, RAND_MAX );
				} while( iSel >= m_iIterations );
			
			iTemp=m_aiIterationMap[i];
			m_aiIterationMap[i]=m_aiIterationMap[iSel];
			m_aiIterationMap[iSel]=iTemp;
			}
		}
	}	

void CProtocol :: CalculateDispWidths( int iTtlWid ) { 
	int iSumDur=0;								// running total of durations
	int iSumWid=0;								// running total of widths
	int iTtlDur=Duration( 0 );					// total duration
	
	for( int iSeg=0; iSeg<m_aSeg.Count(); ++iSeg ) {
		CProtocolSegment * pSeg = Segment(iSeg);
		iSumDur += pSeg->GetDuration( 0.0 );
		pSeg->m_iDispWidth = MulDiv( iTtlWid, iSumDur, iTtlDur ) - iSumWid;
		iSumWid += pSeg->m_iDispWidth;
		}
	}

void CProtocol :: CalculateIterWidths( int iWidth, double dIter ) { 
	int iSumDur=0;								// running total of durations
	int iIterWid=0;								// running total of iteration widths
	int iTtlDur=Duration(dIter);	// total duration
	
	for( int iSeg=0; iSeg<m_aSeg.Count(); ++iSeg ) {
		CProtocolSegment * pSeg = Segment(iSeg);
		iSumDur += pSeg->GetDuration( dIter );
		pSeg->m_iIterWidth = MulDiv( iWidth, iSumDur, iTtlDur ) - iIterWid;
		iIterWid += pSeg->m_iIterWidth;
		}
	}
	
int CProtocol :: TotalDurations( ) { 
	int iMSec = 0;
	for( int iIter=0; iIter<m_iIterations; ++iIter  ) 
		iMSec += Duration( Iteration( iIter ) );
	return iMSec;
	}
		
//-------------------------------------------------------------------	
COptionsGenPulseProtocol :: COptionsGenPulseProtocol() {	//Set Default Values
	m_dBaseAmp=0.0;
	m_dAmpMin=1.0;
	m_dAmpMax=5.0;
	m_iTotalDuration=60000;
	m_iPulseDurMin=100;
	m_iPulseDurMax=2000;
	m_bPulseExp=true;
	m_iSepDurMin=200;
	m_iSepDurMax=200;
	m_bSepExp=false;
	m_bRamp=false;
	}

bool COptionsGenPulseProtocol :: RegistrySave() {
	CRegistryString o("GenPulseProtocol");
	o.AppendDouble(m_dBaseAmp);
	o.AppendDouble(m_dAmpMin);
	o.AppendDouble(m_dAmpMax);
	o.AppendInt(m_iTotalDuration);
	o.AppendInt(m_iPulseDurMin);
	o.AppendInt(m_iPulseDurMax);
	o.AppendBool(m_bPulseExp);
	o.AppendInt(m_iSepDurMin);
	o.AppendInt(m_iSepDurMax);
	o.AppendBool(m_bSepExp);
	o.AppendBool(m_bRamp);
	return o.Save();
	}

bool COptionsGenPulseProtocol :: RegistryLoad() {
	CRegistryString o("GenPulseProtocol");
	if( ! o.Load() ) 
		return false;
	m_dBaseAmp=o.ExtractDouble();
	m_dAmpMin=o.ExtractDouble();
	m_dAmpMax=o.ExtractDouble();
	m_iTotalDuration=o.ExtractInt();
	m_iPulseDurMin=o.ExtractInt();
	m_iPulseDurMax=o.ExtractInt();
	m_bPulseExp=o.ExtractBool();
	m_iSepDurMin=o.ExtractInt();
	m_iSepDurMax=o.ExtractInt();
	m_bSepExp=o.ExtractBool();
	m_bRamp=o.ExtractBool();
	return true;
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
